*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\PrtScreen\\HBF12HLP.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Procedure Main()
*+               Static Procedure HideShow()
*+               Procedure On_Release()
*+               Function PrtScr_Detect()
*+               Procedure DO_SnapShot()
*+               Procedure SENDNOW()
*+
*+       Tables: USE POP3.DBF
*+
*+    Reformatted by Click! 2.05.30 on Mar-6-2020 at  4:46 am
*+
*+--------------------------------------------------------------------

#include "HMG.CH"
#include "DLL.CH"

#define BT_FILEFORMAT_BMP   0
#define BT_FILEFORMAT_JPG   1
#define BT_FILEFORMAT_GIF   2
#define BT_FILEFORMAT_TIF   3
#define BT_FILEFORMAT_PNG   4

#require "hbwin"

REQUEST DBFNTX
REQUEST HB_LANG_DE

*+--------------------------------------------------------------------
*+
*+    Procedure Main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Main

LOCAL xRet
LOCAL nIndex

   SET DATE GERMAN

   IF !FILE( "POP3.DBF" )
      CRE_POP3( "POP3.DBF" )
      Setup()
   ENDIF

   DEFINE WINDOW Form_1 ;
              AT 0, 0 ;
              WIDTH 150 ;
              HEIGHT 100 ;
              TITLE 'hbF12hlp 0.3' ;
              MAIN ;
              ICON "A1MAIN" ;
              NOMAXIMIZE ;
              NOMINIMIZE ;
              NOTIFYICON "A1MAIN" ;
              NOTIFYTOOLTIP "right-click for menue" ;
              NOSHOW ;
              ON RELEASE On_Release() ;
              ON NOTIFYCLICK HideShow()

      DEFINE NOTIFY MENU OF Form_1
         ITEM 'Setup' ACTION Setup()
         ITEM '&Exit' ACTION Form_1.Release
      END MENU

      @ 10, 10 LABEL Label_1 VALUE "Genius by Auge & Ohr" + CRLF + CRLF + "  HMG Version 2020  " ;
              ACTION HideShow() WIDTH 130 HEIGHT 70

   END WINDOW

   xRet := HMG_CallDLL( "User32.DLL", DLL_OSAPI, "RegisterHotKey", Form_1.HANDLE, 1, 0, VK_SNAPSHOT )

   CREATE EVENT PROCNAME PrtScr_Detect() HWND Form_1.HANDLE STOREINDEX nIndex
   EventProcessAllHookMessage( nIndex, .T. )

   Form_1.Hide
   Form_1.Center
   Form_1.Activate

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure HideShow()
*+
*+    Called from ( hbf12hlp.prg )   2 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE HideShow()

   IF IsWindowVisible( GetFormHandle( "Form_1" ) )
      Form_1.Hide
   ELSE
      Form_1.Show
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure On_Release()
*+
*+    Called from ( hbf12hlp.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE On_Release

   HMG_CallDLL( "User32.DLL", DLL_OSAPI, "UnregisterHotKey", Form_1.HANDLE, 1 )

RETURN

*+--------------------------------------------------------------------
*+
*+    Function PrtScr_Detect()
*+
*+--------------------------------------------------------------------
*+
FUNCTION PrtScr_Detect()
LOCAL nHWnd   := EventHWND()
LOCAL nMsg    := EventMSG()
LOCAL nWParam := EventWPARAM()
LOCAL nLParam := EventLPARAM()

   DO CASE
      CASE nMsg == WM_HOTKEY
         DO_SnapShot()
   ENDCASE

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Procedure DO_SnapShot()
*+
*+    Called from ( hbf12hlp.prg )   1 - function prtscr_detect()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DO_SnapShot()
LOCAL Width        := BT_DesktopWidth()
LOCAL Height       := BT_DesktopHeight()
LOCAL Row          := 0
LOCAL Col          := 0
LOCAL nTypePicture := BT_FILEFORMAT_JPG
LOCAL cUser        := GETENV( "USERPROFILE" )
LOCAL hBitmap
LOCAL cFileName

LOCAL cSMPT                            // := "smtp.web.de"
LOCAL nPort                            // := 465
LOCAL lSSL                             // := 1 -> ON
LOCAL cName                            // := "AUGE_OHR"
LOCAL cPass                            // := "cPassword"
LOCAL cFrom                            // := "Spook@Enterprise.US"
LOCAL cTo                              // := "AUGE_OHR@web.de"
LOCAL cSubject := "Test subject"
LOCAL cBody    := "Test body"

   //  %USERPROFILE%\Pictures\Screenshots
   cFileName := cUser + "\Pictures\Err" + DTOS( DATE() ) + STRZERO( SECONDS(), 5 ) + ".JPG"

   hBitmap := BT_BitmapCaptureDesktop( Row, Col, Width, Height )
   BT_BitmapSaveFile( hBitmap, cFileName, nTypePicture )

   IF FILE( cFileName )
      USE POP3.DBF
      cSMPT := ALLTRIM( POP3->SMTP )
      nPort := POP3->PORTSMTP
      lSSL  := POP3->SSL
      cName := ALLTRIM( POP3->USER )
      cPass := ALLTRIM( decrypt( TRIM( POP3->PASSWORD ) ) )
      cFrom := ALLTRIM( POP3->USER )
      cTo := ALLTRIM( POP3->SENDTO )
      CLOSE

      IF MsgYesNo( "Send Snapshot to " + cTo, "send Email",, .T. )
         SENDNOW( cSMPT, nPort, lSSL, cName, cPass, cFrom, cTo, cSubject, cBody, { cFileName } )
      ENDIF
   ENDIF

   // don'nt forget to put Bitmap to Clipboard
   BT_BitmapClipboardPut( Form_1.HANDLE, hBitmap )
   FERASE( cFileName )

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure SENDNOW()
*+
*+    Called from ( hbf12hlp.prg )   1 - procedure do_snapshot()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE SENDNOW( cSMPT, nPort, lSSL, cName, cPass, cFrom, cTo, cSubject, cBody, aAttachment )
LOCAL nLen, nInd
LOCAL bError, lOk := .F.
LOCAL oCdoMessage := win_oleCreateObject( "CDO.Message" )
LOCAL oCdoConf

   IF EMPTY( oCdoMessage )
      MsgInfo( "Error: CDO subsystem not available (needs Windows XP or upper)." )
      RETURN
   ENDIF

   oCdoConf := win_oleCreateObject( "CDO.Configuration" )
   oCdoConf:fields( "http://schemas.microsoft.com/cdo/configuration/sendusing" ) :Value      := 2

   oCdoConf:fields( "http://schemas.microsoft.com/cdo/configuration/smtpserver" ) :Value     := cSMPT
   oCdoConf:fields( "http://schemas.microsoft.com/cdo/configuration/smtpserverport" ) :Value := nPort
   oCdoConf:fields( "http://schemas.microsoft.com/cdo/configuration/smtpusessl" ) :Value     := lSSL

   oCdoConf:fields( "http://schemas.microsoft.com/cdo/configuration/sendusername" ) :Value := cName
   oCdoConf:fields( "http://schemas.microsoft.com/cdo/configuration/sendpassword" ) :Value := cPass

   oCdoConf:fields( "http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout" ) :Value := 60
   oCdoConf:fields( "http://schemas.microsoft.com/cdo/configuration/smtpauthenticate" ) :Value := 1

   oCdoConf:fields:Update()

   oCdoMessage:Configuration := oCdoConf
   oCdoMessage:BodyPart:Charset := "iso-8859-2"                       // "iso-8859-1" "utf-8"

   IF !EMPTY( cSubject )
      oCdoMessage:Subject := cSubject
   ELSE
      oCdoMessage:Subject := "CDO Sample"
   ENDIF

   IF !EMPTY( cBody )
      oCdoMessage:TextBody := cBody
   ELSE
      oCdoMessage:TextBody := "Test Body"
   ENDIF

   oCdoMessage:From := cFrom
   oCdoMessage:To := cTo

   IF !EMPTY( aAttachment )
      nLen := LEN( aAttachment )
      FOR nInd := 1 TO nLen
         oCdoMessage:AddAttachment( aAttachment[ nInd ] )
      NEXT
   ENDIF

   bError := ERRORBLOCK( { | oErr | BREAK( oErr ) } )
   BEGIN SEQUENCE
      oCdoMessage:Send()
      lOk := .T.
   RECOVER
      ERRORBLOCK( bError )
      MsgInfo( "Error: CDO send error.", win_oleErrorText() )
      lOk := .F.
   END SEQUENCE
   ERRORBLOCK( bError )

   oCdoMessage := NIL
   oCdoConf := NIL

   IF lOk = .T.
      msgInfo( "Mail send from " + cFrom + CRLF + ;
               "to " + cTo + CRLF + ;
               "on Port " + LTRIM( STR( nPort ) ) + CRLF + ;
               "via " + cSMPT )
   ENDIF
RETURN

*+ EOF: HBF12HLP.PRG