*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\PrtScreen\\SETUP.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Function Setup()
*+               Procedure CheckValue()
*+               Procedure CheckCaption()
*+               Procedure Refresh()
*+               Procedure SAVE()
*+               Procedure OpenTables()
*+               Procedure CloseTables()
*+               Procedure Cre_POP3()
*+               Function decrypt()
*+               Function encrypt()
*+
*+       Tables: USE POP3
*+               USE &datei EXCLUSIVE
*+
*+    Reformatted by Click! 2.05.30 on Mar-6-2020 at  4:46 am
*+
*+--------------------------------------------------------------------

#include "hmg.ch"

// use your own key
#define KEY4CRYPT "bhjalskfdhj62defbgfd124cdgh124fC"

*+--------------------------------------------------------------------
*+
*+    Function Setup()
*+
*+    Called from ( hbf12hlp.prg )   2 - procedure main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Setup()

   DEFINE WINDOW Win_Setup ;
              AT 0, 0 ;
              WIDTH 380 ;
              HEIGHT 300 ;
              TITLE 'Setup ' ;
              ICON "ICOSETUP" ;
              BACKCOLOR nil ;
              NOSIZE ;
              NOMAXIMIZE ;
              NOMINIMIZE ;
              ON INIT OpenTables() ;
              ON RELEASE CloseTables()

      @ 010, 010 BUTTON BTN_SAVE ;
              CAPTION '&Save' ;
              PICTURE 'MYOK' LEFT ;
              ACTION( SAVE(), Refresh(), Win_Setup.Release )

      @ 060, 55 LABEL LABEL_1 VALUE 'Send to ' FONTCOLOR nil BACKCOLOR nil

      @ 110, 55 LABEL LABEL_3 VALUE 'SSL     ' FONTCOLOR nil BACKCOLOR nil
      @ 140, 55 LABEL LABEL_4 VALUE 'User    ' FONTCOLOR nil BACKCOLOR nil
      @ 170, 55 LABEL LABEL_5 VALUE 'Password' FONTCOLOR nil BACKCOLOR nil
      @ 200, 55 LABEL LABEL_6 VALUE 'Smtp    ' FONTCOLOR nil BACKCOLOR nil
      @ 230, 55 LABEL LABEL_7 VALUE 'PortSmtp' FONTCOLOR nil BACKCOLOR nil

      @ 060, 125 TEXTBOX TEXT_1 ;
              FIELD POP3->SENDTO ;
              MAXLENGTH 80 ;
              TOOLTIP "Receiver Mail Adress : Test@Test.COM"

      @ 110, 125 CHECKBOX CHECK_3 ;
              CAPTION "" ;
              FIELD POP3->SSL ;
              FONTCOLOR nil ;
              ON ENTER CheckValue() ;
              ON CHANGE CheckCaption() ;
              TOOLTIP "check it to use SSL"

      @ 140, 125 TEXTBOX TEXT_4 ;
              FIELD POP3->USER ;
              MAXLENGTH 80 ;
              TOOLTIP "your Username for SMTP"

      @ 170, 125 TEXTBOX TEXT_5 ;
              FIELD decrypt( TRIM( POP3->PASSWORD ) ) ;
              MAXLENGTH 80 ;
              TOOLTIP "your Password for SMTP"

      @ 200, 125 TEXTBOX TEXT_6 ;
              FIELD POP3->SMTP ;
              MAXLENGTH 80 ;
              TOOLTIP "SMTP Adress : smtp.web.de "

      @ 230, 125 TEXTBOX TEXT_7 ;
              NUMERIC ;
              FIELD POP3->PORTSMTP ;
              MAXLENGTH 4 ;
              TOOLTIP "SMTP Port Number"

   END WINDOW

   Win_Setup.CHECK_3.Width := 120
   Win_Setup.CHECK_3.Height := 24

   CENTER WINDOW Win_Setup
   Win_Setup.Text_1.SetFocus

   ON KEY ESCAPE OF Win_Setup ACTION Win_Setup.Release

   Win_Setup.Activate

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Procedure CheckValue()
*+
*+    Called from ( setup.prg )   1 - function setup()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE CheckValue()

   IF USED()
      IF Win_Setup.CHECK_3.Value = .T.
         Win_Setup.CHECK_3.Value := .F.
      ELSE
         Win_Setup.CHECK_3.Value := .T.
      ENDIF
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure CheckCaption()
*+
*+    Called from ( setup.prg )   1 - function setup()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE CheckCaption()

   IF USED()
      IF Win_Setup.CHECK_3.Value = .F.
         Win_Setup.Check_3.Caption := "disable"
      ELSE
         Win_Setup.Check_3.Caption := "enable"
      ENDIF
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure Refresh()
*+
*+    Called from ( setup.prg )   1 - function setup()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Refresh

   Win_Setup.Text_1.Refresh
   Win_Setup.Check_3.Refresh
   Win_Setup.Text_4.Refresh
   Win_Setup.Text_5.Refresh
   Win_Setup.Text_6.Refresh
   Win_Setup.Text_7.Refresh
   Win_Setup.Text_1.SetFocus

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure SAVE()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE SAVE

   IF RLOCK()
      Win_Setup.Text_1.Save
      Win_Setup.Check_3.Save
      Win_Setup.Text_4.Save
      //     Win_Setup.Text_5.Save
      Win_Setup.Text_6.Save
      Win_Setup.Text_7.Save

      REPLACE POP3->PASSWORD WITH encrypt( TRIM( Win_Setup.Text_5.Value ) )
      UNLOCK
      COMMIT
   ELSE
      MsgInfo( "can not lock record" )
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure OpenTables()
*+
*+    Called from ( setup.prg )   1 - function setup()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE OpenTables
   USE POP3
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure CloseTables()
*+
*+    Called from ( setup.prg )   1 - function setup()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE CloseTables
   CLOSE
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure Cre_POP3()
*+
*+    Called from ( hbf12hlp.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Cre_POP3( datei )
LOCAL i, iMax
LOCAL field_list := {}

   AADD( field_list, { "SSL"     , "L", 1, 0 } )
   AADD( field_list, { "USER"    , "C", 80, 0 } )
   AADD( field_list, { "PASSWORD", "C", 80, 0 } )
   AADD( field_list, { "SMTP"    , "C", 80, 0 } )
   AADD( field_list, { "PORTSMTP", "N", 4, 0 } )
   AADD( field_list, { "SENDTO"  , "C", 80, 0 } )

   DBCREATE( datei, field_list, "DBFNTX" )

   USE &datei EXCLUSIVE
   APPEND BLANK
   CLOSE

RETURN

*+--------------------------------------------------------------------
*+
*+    Function decrypt()
*+
*+    Called from ( hbf12hlp.prg )   1 - procedure do_snapshot()
*+                ( setup.prg )   1 - function setup()
*+
*+--------------------------------------------------------------------
*+
FUNCTION decrypt( cIn )
LOCAL cOut
   cOut := CRYPT( cIn, KEY4CRYPT )
RETURN cOut

*+--------------------------------------------------------------------
*+
*+    Function encrypt()
*+
*+    Called from ( setup.prg )   1 - procedure save()
*+
*+--------------------------------------------------------------------
*+
FUNCTION encrypt( cIn )
LOCAL cOut
   cOut := CRYPT( cIn, KEY4CRYPT )
RETURN cOut

*+ EOF: SETUP.PRG